<template>
    <div class="wrapper">
        <div class="chart-list">
            <div class="chart medium-width">
                <div class="chart-title no-filter">
                    <h3>Overview of Groups with Interactive Stages marked</h3>
                </div>
                <div class="chart-visualization">
                    <table class="text-center">
                        <thead>
                        <tr>
                            <th>Group</th>
                            <th>Application</th>
                            <th>Texturing</th>
                            <th>Lighting</th>
                            <th>Rasterization</th>
                        </tr>
                        </thead>
                        <tbody>
                        <tr v-for="(variant, key) in interactive">
                            <td>
                                {{key}}
                            </td>
                            <td class="bold"
                                :class="{'color-green': variant[0] === true, 'color-red': variant[0] === false}">
                                {{variant[0] === true ? "✔" : "X"}}
                            </td>
                            <td class="bold"
                                :class="{'color-green': variant[1] === true, 'color-red': variant[1] === false}">
                                {{variant[1] === true ? "✔" : "X"}}
                            </td>
                            <td class="bold"
                                :class="{'color-green': variant[2] === true, 'color-red': variant[2] === false}">
                                {{variant[2] === true ? "✔" : "X"}}
                            </td>
                            <td class="bold"
                                :class="{'color-green': variant[3] === true, 'color-red': variant[3] === false}">
                                {{variant[3] === true ? "✔" : "X"}}
                            </td>
                        </tr>
                        </tbody>
                    </table>
                </div>
            </div>
            <div class="chart small-width">
                <div class="chart-title no-filter">
                    <h3>Distribution of Groups (without incomplete participations)</h3>
                </div>
                <div class="chart-visualization">
                    <apexchart height="100%" :options="getGroupCountsChartOptions()" :series="getGroupCounts()" @click="getGroupCountsChartOptions().chart.events.click" @dataPointSelection="handleSelection"></apexchart>
                </div>
            </div>
            <div class="chart small-width">
                <div class="chart-title no-filter">
                    <h3>Incomplete Participations (in % of total participations)</h3>
                </div>
                <div class="chart-visualization single-line">
                    {{toPercentage(getIncompleteParticipationRelative())}}%
                </div>
            </div>
            <div class="chart large-width">
                <div class="chart-title">
                    <h3>Timings per Stage</h3>
                </div>
                <div class="chart-visualization">
                    <HorizontalBoxPlotChart :dataset="activeDataSet"
                                            :fields="['time_application', 'time_texturing', 'time_lighting', 'time_rasterization']"
                                            :labels="['Application', 'Texturing', 'Lighting', 'Rasterization']">

                    </HorizontalBoxPlotChart>
                </div>
            </div>
            <div class="chart medium-large-width large-height">
                <div class="chart-title">
                    <h3>Evaluation Immersion (avg. 40% - 60%)</h3>
                </div>
                <div class="chart-visualization">
                    <HorizontalBoxPlotChart :dataset="activeDataSet"
                                            :fields="getSurveyKeys('immersion')"
                                            :labels="getSurveyLabels('immersion')"
                                            :min="0.9"
                                            :max="9.1"
                                            :s1="40"
                                            :q1="50"
                                            :q3="50"
                                            :s3="60">

                    </HorizontalBoxPlotChart>
                </div>
            </div>
            <div class="chart medium-large-width large-height">
                <div class="chart-title">
                    <h3>Evaluation Health (avg. 40% - 60%)</h3>
                </div>
                <div class="chart-visualization">
                    <HorizontalBoxPlotChart :dataset="activeDataSet"
                                            :fields="getSurveyKeys('health')"
                                            :labels="getSurveyLabels('health')"
                                            :min="0.9"
                                            :max="9.1"
                                            :s1="40"
                                            :q1="50"
                                            :q3="50"
                                            :s3="60">

                    </HorizontalBoxPlotChart>
                </div>
            </div>
            <div class="chart small-width">
                <div class="chart-title">
                    <h3>Interactions: "bewegte"</h3>
                </div>
                <div class="chart-visualization">
                    <HorizontalBoxPlotChart :dataset="getSubset(activeInteractionDataSet, 'interactions.bewegte')"
                                            :fields="['subsetItem']"
                                            :labels="['']"
                                            :min="0"
                                            :max="40000"
                    >

                    </HorizontalBoxPlotChart>
                </div>
            </div>
            <div class="chart small-width">
                <div class="chart-title">
                    <h3>Interactions: "veränderte"</h3>
                </div>
                <div class="chart-visualization">
                    <HorizontalBoxPlotChart :dataset="getSubset(activeInteractionDataSet, 'interactions.veränderte')"
                                            :fields="['subsetItem']"
                                            :labels="['']"
                                            :min="0"
                                            :max="12000"
                    >

                    </HorizontalBoxPlotChart>
                </div>
            </div>
            <div class="chart small-width">
                <div class="chart-title">
                    <h3>Interactions: "zeigte" - VR only</h3>
                </div>
                <div class="chart-visualization">
                    <HorizontalBoxPlotChart :dataset="getSubset(activeInteractionDataSet, 'interactions.zeigte')"
                                            :fields="['subsetItem']"
                                            :labels="['']"
                                            :min="0"
                                            :max="15000"
                    >

                    </HorizontalBoxPlotChart>
                </div>
            </div>
            <div class="chart small-width">
                <div class="chart-title">
                    <h3>Interactions: "interagierte" - VR only</h3>
                </div>
                <div class="chart-visualization">
                    <HorizontalBoxPlotChart :dataset="getSubset(activeInteractionDataSet, 'interactions.interagierte')"
                                            :fields="['subsetItem']"
                                            :labels="['']"
                                            :min="0"
                                            :max="1000"
                    >

                    </HorizontalBoxPlotChart>
                </div>
            </div>
            <div class="chart small-width">
                <div class="chart-title">
                    <h3>Interactions: "fixierte" - VR only</h3>
                </div>
                <div class="chart-visualization">
                    <HorizontalBoxPlotChart :dataset="getSubset(activeInteractionDataSet, 'interactions.fixierte')"
                                            :fields="['subsetItem']"
                                            :labels="['']"
                                            :min="0"
                                            :max="7000"
                    >

                    </HorizontalBoxPlotChart>
                </div>
            </div>
            <div class="chart small-width">
                <div class="chart-title">
                    <h3>Interactions: "platzierte"</h3>
                </div>
                <div class="chart-visualization">
                    <HorizontalBoxPlotChart :dataset="getSubset(activeInteractionDataSet, 'interactions.platzierte')"
                                            :fields="['subsetItem']"
                                            :labels="['']"
                                            :min="0"
                                            :max="50"
                    >

                    </HorizontalBoxPlotChart>
                </div>
            </div>
            <div class="chart medium-large-width">
                <div class="chart-title">
                    <h3>Survey-Score (the higher, the more immersive/better was the experience)</h3>
                </div>
                <div class="chart-visualization">
                    <HorizontalBoxPlotChart :dataset="getSubset(activeInteractionDataSet, 'surveyScore')"
                                            :fields="['subsetItem']"
                                            :labels="['']"
                                            :min="-250"
                                            :max="600"
                    >

                    </HorizontalBoxPlotChart>
                </div>
            </div>
            <div class="chart medium-large-width">
                <div class="chart-title">
                    <h3>Task-Score (the higher, the more tasks were solved correctly more quickly)</h3>
                </div>
                <div class="chart-visualization">
                    <HorizontalBoxPlotChart :dataset="getSubset(activeInteractionDataSet, 'scoreAvg')"
                                            :fields="['subsetItem']"
                                            :labels="['']"
                                            :min="0"
                                            :max="0.5"
                    >

                    </HorizontalBoxPlotChart>
                </div>
            </div>
        </div>
        <div class="filter-list">
            <h2>
                Global Filters
            </h2>
            <div class="message information">
                Using the current filters, {{activeDataSet.length}} data elements are recognized for visualization. Filters are not applied to visualizations marked with <span class="no-filter">*</span>
            </div>
            <div class="filter">
                <h3>
                    Group
                </h3>
                <span class="multi-checkbox" v-for="variant in filterOptions.group">
                    <input type="checkbox" :id="variant" @change="triggerGroupFilter(variant)" :checked="isGroupFiltered(variant)">
                    <label :for="variant">{{variant}}</label>
                </span>
            </div>
            <div class="filter">
                <h3>
                    Platform
                </h3>
                <span class="multi-checkbox" v-for="platform in filterOptions.platform">
                    <input type="checkbox" :id="platform" @change="triggerPlatformFilter(platform)" :checked="isPlatformFiltered(platform)">
                    <label :for="platform">{{platform}}</label>
                </span>
            </div>
            <div class="filter">
                <h3>
                    Timings Application (in minutes)
                </h3>

                <span class="margin-top-extra">
                    <Slider v-model="activeFilters.time_application" :max="60" @update="updateFilters();"></Slider>
                </span>
            </div>
            <div class="filter">
                <h3>
                    Timings Texturing (in minutes)
                </h3>

                <span class="margin-top-extra">
                    <Slider v-model="activeFilters.time_texturing" :max="60" @update="updateFilters();"></Slider>
                </span>
            </div>
            <div class="filter">
                <h3>
                    Timings Lighting (in minutes)
                </h3>

                <span class="margin-top-extra">
                    <Slider v-model="activeFilters.time_lighting" :max="60" @update="updateFilters();"></Slider>
                </span>
            </div>
            <div class="filter">
                <h3>
                    Timings Rasterization (in minutes)
                </h3>

                <span class="margin-top-extra">
                    <Slider v-model="activeFilters.time_rasterization" :max="60" @update="updateFilters();"></Slider>
                </span>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">
import interactive from "../data/interactive.json";
import endingTimesImport from "../data/ending_times.json";
import incomplete from "../data/incomplete.json";
import interactionStats from "../data/interaction_stats.json";

const endingTimes : object = {};

for(let endingTime in endingTimesImport) {
    endingTimes[endingTime] = {
        ...{
            pseudonym: endingTime
        },
        ...endingTimesImport[endingTime]
    };
}

import Slider from "@vueform/slider";
import HorizontalBoxPlotChart from "@/components/HorizontalBoxPlotChart.vue";

import {type Ref, ref} from "vue";

const variants = ["A", "B", "C", "D", "E", "F"];

const filterOptions = {
    group: ["A", "B", "C", "D", "E", "F"],
    platform: ["EduXR:VR", "EduXR:Desktop"],
    time_application: {
        min: 0,
        max: 60
    },
    time_texturing: {
        min: 0,
        max: 60
    },
    time_lighting: {
        min: 0,
        max: 60
    },
    time_rasterization: {
        min: 0,
        max: 60
    }
}

const activeFilters = ref({
    group: ["A", "B", "C", "D", "E", "F"],
    platform: ["EduXR:VR", "EduXR:Desktop"],
    time_application: [0, 60],
    time_texturing: [0, 60],
    time_lighting: [0, 60],
    time_rasterization: [0, 60],
})

let activeDataSet : Ref<any[]> = ref([]);
let activeInteractionDataSet : Ref<any[]> = ref([]);

function getPlatformBase(platform : string) {
    const platformParts = platform.split(":");

    return platformParts[0] + ":" + platformParts[1];
}

function updateFilters() {
    let dataset = Object.values(endingTimes);

    // Filter by group
    dataset = dataset.filter(dataElement => activeFilters.value.group.includes(dataElement.group));

    // Filter by platform
    dataset = dataset.filter(dataElement => activeFilters.value.platform.includes(getPlatformBase(dataElement.platform)))

    // Filter by application timings
    dataset = dataset.filter(dataElement => activeFilters.value.time_application[0] <= dataElement.time_application && dataElement.time_application <= activeFilters.value.time_application[1])

    // Filter by texturing timings
    dataset = dataset.filter(dataElement => activeFilters.value.time_texturing[0] <= dataElement.time_texturing && dataElement.time_texturing <= activeFilters.value.time_texturing[1])

    // Filter by lighting timings
    dataset = dataset.filter(dataElement => activeFilters.value.time_lighting[0] <= dataElement.time_lighting && dataElement.time_lighting <= activeFilters.value.time_lighting[1])

    // Filter by rasterization timings
    dataset = dataset.filter(dataElement => activeFilters.value.time_rasterization[0] <= dataElement.time_rasterization && dataElement.time_rasterization <= activeFilters.value.time_rasterization[1])

    let datasetInteractions : any[] = [];

    for(let dataEntry of dataset) {
        datasetInteractions.push(interactionStats[dataEntry.pseudonym]);
    }

    activeDataSet.value = dataset;
    activeInteractionDataSet.value = datasetInteractions;
}

updateFilters();

function getAverage(dataset, key) {
    let totalCount = 0;

    for(let element of dataset) {
        let subElement = element;
        for(let keyPart of key.split(".")) {
            subElement = subElement[keyPart]
        }
        totalCount += subElement;
    }

    return dataset.length > 0 ? Math.round(totalCount / dataset.length) : 0;
}

function getSubset(dataset, key) {
    let subset : any[] = [];

    for(let element of dataset) {
        let subElement = element;
        for(let keyPart of key.split(".")) {
            subElement = subElement[keyPart]
        }
        subset.push({subsetItem: subElement})
    }

    return subset;
}

function isGroupFiltered(variant) {
    return activeFilters.value.group.includes(variant);
}

function triggerGroupFilter(variant) {
    if(isGroupFiltered(variant)) {
        activeFilters.value.group.splice(activeFilters.value.group.indexOf(variant), 1);
    } else {
        activeFilters.value.group.push(variant);
    }

    updateFilters();
}

function isPlatformFiltered(platform) {
    return activeFilters.value.platform.includes(platform);
}

function triggerPlatformFilter(platform) {
    if(isPlatformFiltered(platform)) {
        activeFilters.value.platform.splice(activeFilters.value.platform.indexOf(platform), 1);
    } else {
        activeFilters.value.platform.push(platform);
    }

    updateFilters();
}

function getGroupCountsChartOptions() {
    return {
        chart: {
            type: 'donut',
            height: "100%",
            events: {
                click: function(event, chartContext, config) {
                    console.log("CLICK", event, chartContext, config)
                }
            }
        },
        colors: ['#8931EF', '#F2CA19', '#FF00BD', '#0057E9', '#87E911', '#E11845'],
        labels: variants.map(item => "Variant " + item),
        dataLabels: {
            formatter: function(val, { seriesIndex, w }) {
                return w.config.series[seriesIndex];
            }
        }
    };
}

function getGroupCounts() {
    const counts = [0, 0, 0, 0, 0, 0];

    for(let endingTime of Object.values(endingTimes)) {
        counts[variants.indexOf(endingTime.group)] += 1;
    }

    return counts;
}

function handleSelection(event, chartContext, config) {
    console.log("POINT SELECT", config.dataPointIndex)
}

function toPercentage(value: number) {
    return Math.round(value * 10000) / 100;
}

function getIncompleteParticipationRelative() {
    return incomplete.length / (Object.keys(endingTimes).length);
}

const surveyResultMappings = {
    immersion: {
        "Please indicate to what extent you agree with each statement: [The visual aspects made me feel part of the virtual environment.]": "The visual aspects made me feel part of the virtual environment.",
        "Please indicate to what extent you agree with each statement: [The feeling of moving around in the virtual environment was convincing.]": "The feeling of moving around in the virtual environment was convincing.",
        "Please indicate to what extent you agree with each statement: [I was immersed in the virtual environment.]": "I was immersed in the virtual environment.",
        "Please indicate to what extent you agree with each statement: [I felt stimulated by the virtual environment.]": "I felt stimulated by the virtual environment.",
        "Please indicate to what extent you agree with each statement: [I was so absorbed in the virtual environment that I didn't notice what was happening around me.]": "I was so absorbed in the virtual environment that I didn't notice what was happening around me.",
        "Please indicate to what extent you agree with each statement: [I was so immersed in the virtual environment, as if I were in the game instead of just controlling it and looking at it from the outside.]": "I was so immersed in the virtual environment, as if I were in the game instead of just controlling it and looking at it from the outside.",
        "Please indicate to what extent you agree with each statement: [I felt physically present in the virtual environment.]": "I felt physically present in the virtual environment.",
        "Please indicate to what extent you agree with each statement: [I was so absorbed in the virtual environment that I lost my sense of time.]": "I was so absorbed in the virtual environment that I lost my sense of time.",
        "Please indicate to what extent you agree with each statement: [Time seemed to pass differently than it normally does.]": "Time seemed to pass differently than it normally does.",
        "Please indicate to what extent you agree with each statement: [Time seemed to pass faster.]": "Time seemed to pass faster.",
        "Please indicate to what extent you agree with each statement: [ I lost my sense of time.]": "I lost my sense of time.",
        "Please indicate to what extent you agree with each statement: [ I didn't care what others thought of me.]": "I didn't care what others thought of me.",
        "Please indicate to what extent you agree with each statement: [ I felt like I was experiencing an exciting moment.]": "I felt like I was experiencing an exciting moment.",
        "Please indicate to what extent you agree with each statement: [ I felt at ease with the experience.]": "I felt at ease with the experience.",
        "Please indicate to what extent you agree with each statement: [When I mention the experience in the virtual world, I want to share my impressions about it.]": "When I mention the experience in the virtual world, I want to share my impressions about it.",
        "Please indicate to what extent you agree with each statement: [ I enjoyed being in the virtual environment.]": "I enjoyed being in the virtual environment.",
        "Please indicate to what extent you agree with each statement: [It was so exciting that I could have stayed in the virtual environment for hours.]": "It was so exciting that I could have stayed in the virtual environment for hours.",
        "Please indicate to what extent you agree with each statement: [ I felt like I was being distracted to reduce my discomfort.]": "I felt like I was being distracted to reduce my discomfort.",
        "Please indicate to what extent you agree with each statement: [I found my mind drifting in the virtual environment.]": "I found my mind drifting in the virtual environment.",
        "Please indicate to what extent you agree with each statement: [When my actions were going well, I felt like I was in a frenzy.]": "When my actions were going well, I felt like I was in a frenzy.",
        "Please indicate to what extent you agree with each statement: [While I was using the controllers/headset, time dragged.]": "While I was using the controllers/headset, time dragged.",
    },
    technical: {
        "Please indicate to what extent you agree with each statement: [The controllers that I could use to move around the virtual environment had a natural effect on me.]": "The controllers that I could use to move around the virtual environment had a natural effect on me.",
        "Please indicate to what extent you agree with each statement: [I could actively explore the virtual environment visually.]": "I could actively explore the virtual environment visually.",
        "Please indicate to what extent you agree with each statement: [I was able to examine objects in detail.]": "I was able to examine objects in detail.",
        "Please indicate to what extent you agree with each statement: [I could examine objects from several angles.]": "I could examine objects from several angles.",
        "Please indicate to what extent you agree with each statement: [By the end of the experience, I was confident with the movements and interaction possibilities.]": "By the end of the experience, I was confident with the movements and interaction possibilities.",
        "Please indicate to what extent you agree with each statement: [The quality of the VR technology distracted me from my task.]": "The quality of the VR technology distracted me from my task.",
        "Please indicate to what extent you agree with each statement: [I could concentrate on my task independently of the controllers.]": "I could concentrate on my task independently of the controllers.",
        "Please indicate to what extent you agree with each statement: [I have correctly identified the sounds in the virtual environment.]": "I have correctly identified the sounds in the virtual environment.",
        "Please indicate to what extent you agree with each statement: [I have correctly localised the sounds in the virtual environment.]": "I have correctly localised the sounds in the virtual environment.",
        "Please indicate to what extent you agree with each statement: [ I felt like I could control my actions perfectly.]": "I felt like I could control my actions perfectly.",
        "Please indicate to what extent you agree with each statement: [ I felt like I always knew exactly what to do.]": "I felt like I always knew exactly what to do.",
        "Please indicate to what extent you agree with each statement: [ I felt like I was in control of the situation.]": "I felt like I was in control of the situation.",
        "Please indicate to what extent you agree with each statement: [I think the controllers/headset were easy to use.]": "I think the controllers/headset were easy to use.",
        "Please indicate to what extent you agree with each statement: [ I thought the virtual environment was too inconsistent.]": "I thought the virtual environment was too inconsistent.",
        "Please indicate to what extent you agree with each statement: [I found the controllers/headset cumbersome to use.]": "I found the controllers/headset cumbersome to use.",
        "Please indicate to what extent you agree with each statement: [The controllers/headset bored me to death.]": "The controllers/headset bored me to death.",
        "Please indicate to what extent you agree with each statement: [ I enjoyed learning how to use the controllers/headset.]": "I enjoyed learning how to use the controllers/headset.",
        "Please indicate to what extent you agree with each statement: [I enjoyed using the controllers/headset.]": "I enjoyed using the controllers/headset.",
        "Please indicate to what extent you agree with each statement: [I felt confident selecting objects in the virtual environment.]": "I felt confident selecting objects in the virtual environment.",
        "Please indicate to what extent you agree with each statement: [I was safe with the controls in the virtual environment.]": "I was safe with the controls in the virtual environment.",
        "Please indicate to what extent you agree with each statement: [I felt confident moving through the virtual environment with the controllers / headset.]": "I felt confident moving through the virtual environment with the controllers / headset.",
        "Please indicate to what extent you agree with each statement: [I feel confident in using the terms for the controllers / headset.]": "I feel confident in using the terms for the controllers / headset.",
        "Please indicate to what extent you agree with each statement: [I am confident in learning advanced skills in the virtual environment with the headset.]": "I am confident in learning advanced skills in the virtual environment with the headset.",
        "Please indicate to what extent you agree with each statement: [I feel able to describe the functions of the controller / headset for the virtual environment.]": "I feel able to describe the functions of the controller / headset for the virtual environment.",
        "Please indicate to what extent you agree with each statement: [It would be easy for me to become good at using the virtual environment.]": "It would be easy for me to become good at using the virtual environment.",
        "Please indicate to what extent you agree with each statement: [I have no problem learning to operate the virtual environment.]": "I have no problem learning to operate the virtual environment.",
        "Please indicate to what extent you agree with each statement: [Using controller / the headset is a bad idea.]": "Using controller / the headset is a bad idea.",
        "Please indicate to what extent you agree with each statement: [Using controllers / headset would make jobs in general more interesting.]": "Using controllers / headset would make jobs in general more interesting.",
        "Please indicate to what extent you agree with each statement: [I would like to work with controller and heatsets. ]": "I would like to work with controller and heatsets.",
        "Please indicate to what extent you agree with each statement: [I can imagine investing my resources (e.g. space and time) to be able to use the virtual environment privately as well.]": "I can imagine investing my resources (e.g. space and time) to be able to use the virtual environment privately as well.",
        "Please indicate to what extent you agree with each statement: [The next time I would use the virtual environment, the interactions with the environment would be clear and understandable to me.]": "The next time I would use the virtual environment, the interactions with the environment would be clear and understandable to me.",
        "Please now evaluate the virtual environment with regard to the following characteristics: [Impractical|Practical]": "Please now evaluate the virtual environment with regard to the following characteristics: [Impractical|Practical]"
    },
    health: {
        "Please indicate to what extent you agree with each statement: [ I enjoyed the experience so much that I was energetic.]": "I enjoyed the experience so much that I was energetic.",
        "Please indicate to what extent you agree with each statement: [ I was nervous in the virtual environment.]": "I was nervous in the virtual environment.",
        "Please indicate to what extent you agree with each statement: [During the experience I was exhausted.]": "During the experience I was exhausted.",
        "Please indicate to what extent you agree with each statement: [During the experience I had a headache.]": "During the experience I had a headache.",
        "Please indicate to what extent you agree with each statement: [During the experience my eyes hurt.]": "During the experience my eyes hurt.",
        "Please indicate to what extent you agree with each statement: [During the experience I had increased salivation.]": "During the experience I had increased salivation.",
        "Please indicate to what extent you agree with each statement: [During the experience I felt sick.]": "During the experience I felt sick.",
        "Please indicate to what extent you agree with each statement: [During the experience I had pressure in my head.]": "During the experience I had pressure in my head.",
        "Please indicate to what extent you agree with each statement: [I felt dizzy during the experience.]": "I felt dizzy during the experience.",
        "Please indicate to what extent you agree with each statement: [During the experience I had problems with balance.]": "During the experience I had problems with balance.",
    }
}

function getSurveyKeys(category) {
    return Object.keys(surveyResultMappings[category]);
}

function getSurveyLabels(category) {
    return Object.values(surveyResultMappings[category]);
}
</script>